

extern int     Magic          =  1032;
extern double  BuyStopPrice   =  0.0;
extern int     StopLoss       =  70;
extern int     TakeProfit     =  140;
extern double  Lots_1         =  0.1;
extern double  Lots_2         =  0.2;
extern double  Lots_3         =  0.3;
extern double  Lots_4         =  0.4;
extern double  Lots_5         =  0.5;
extern double  Lots_6         =  0.6;
extern double  Lots_7         =  0.7;
extern double  Lots_8         =  0.8;
extern double  Lots_9         =  0.9;
extern double  Lots_10        =  1.0;

int            slip           =  3;

bool           flag           =  1;    //1 = restart flag
double         BSP            =  0.0;  //last used BuyStopPrice

int            t1, t2;                 //Temporary ticket holders for the first two orders of current series
int            T;                      //Current pending order array index (0, 1, 2, 3, 4, 5, 6, 7, 8, 9)
int            tArray[10];             //Holds current series ticket numbers
   
double         LotsArray[10];          //Convenience array. Holds input parameters

int init()
{
   LotsArray[0] = Lots_1;
   LotsArray[1] = Lots_2;
   LotsArray[2] = Lots_3;
   LotsArray[3] = Lots_4;
   LotsArray[4] = Lots_5;
   LotsArray[5] = Lots_6;
   LotsArray[6] = Lots_7;
   LotsArray[7] = Lots_8;
   LotsArray[8] = Lots_9;
   LotsArray[9] = Lots_10;
   return(0);
}

int deinit()
{
   restart(-2);
   return(0);
}

int start()

{
   if(flag == 1 && BSP == BuyStopPrice) Comment("The system is ready to input BuyStopPrice");
   

   
   else //else - needed
   {
      Comment("System is working");
        
      if(flag==1) //  
      {
         t1 = OrderSend(Symbol(), OP_BUYSTOP, LotsArray[0], BuyStopPrice, slip, BuyStopPrice - StopLoss*Point, BuyStopPrice + TakeProfit*Point, NULL, Magic);
         if(t1 < 0)  {restart(1); return (0);}
         
         t2 = OrderSend(Symbol(), OP_SELLSTOP, LotsArray[0], BuyStopPrice - StopLoss*Point, slip, BuyStopPrice, BuyStopPrice - StopLoss*Point - TakeProfit*Point, NULL, Magic);
         if(t2 < 0)  {restart(2); return (0);}
         
         flag = 0; BSP = BuyStopPrice;
      }
      
      else
      
      {         
         
         if(T == 0)
         {
            OrderSelect(t1, SELECT_BY_TICKET);
            if(OrderType() == OP_BUY)
            {
               OrderDelete(t2);
               tArray[0] = t1;
               tArray[1] = OrderSend(Symbol(), OP_SELLSTOP, LotsArray[1], BuyStopPrice - StopLoss*Point, slip, BuyStopPrice, BuyStopPrice - StopLoss*Point - TakeProfit*Point, NULL, Magic);
               T = 1;
               if(tArray[1] < 0)  {restart(0); return (0);}
               
               return (0);
            }   
         
            OrderSelect(t2, SELECT_BY_TICKET);      
            if(OrderType() == OP_SELL)
            {
               OrderDelete(t1);
               tArray[0] = t2;
               tArray[1] = OrderSend(Symbol(), OP_BUYSTOP, LotsArray[1], BuyStopPrice, slip, BuyStopPrice - StopLoss*Point, BuyStopPrice + TakeProfit*Point, NULL, Magic);
               T = 1;
               if(tArray[1] < 0)  {restart(0); return (0);}
               
               return(0);            
            }
            
            return (0); //none of the first two orders have been opened   
         }
         
         
         else
         {
            if(!OrderSelect(tArray[T-1], SELECT_BY_TICKET)) Alert("???");
            
            double P = OrderClosePrice();
            
            
            if(P == OrderTakeProfit())
            
            {
               //the pending order will be deleted by restart() function
               restart(100);
               return (0);
            }

            else if(P == OrderStopLoss())
            {
               if(T == 9)  //highest order in series (order number 10) will have index = 9
                  {restart(10);  return (0);}
               
              
               else
               
               {
                  int cmd;
                  
                  OrderSelect(tArray[T-1], SELECT_BY_TICKET);
                  
                  if(OrderType() == OP_BUY)
                     cmd = OP_BUYSTOP;
                  else
                     cmd = OP_SELLSTOP;
                     
                  tArray[T+1] = OrderSend(Symbol(), cmd, LotsArray[T+1], OrderOpenPrice(), slip, OrderStopLoss(), OrderTakeProfit(), NULL, Magic);
                  T++;
                  if(tArray[T] < 0)  {restart(0); return (0);}
                  
                  return (0);
               }
            }       
         }
      }
   }  
   return(0);
}


void restart(int code)           //preparing everything for new series
{
   int i;
   
   switch(code)
   {
      case 1:     Alert("Could not open first BUYSTOP order. Error code: ", GetLastError(), " Restarting...");
                  break;
      case 2:     Alert("Could not open first SELLSTOP order. Error code: ", GetLastError(), " Restarting...");
                  break;
      case 0:     Alert("Could not open pending order number ", T, " in current series. Error code: ", GetLastError(), " Restarting...");
                  break;
      case 100:   Alert("Profit reached! Restarting...");
                  break;         
      case 10:    Alert("10 orders done. Series finished. Restarting...");
                  break;
      case -1:    Alert("Last order wasn\'t closed buy stoploss or takeprofit. Restarting...");
                  break;
      case -2:    Alert("Deinit. Deleting all pending orders.");
                  break;                  
   }

   
 for(i=0; i<10; i++)           //deleting all pending orders
   {
      OrderSelect(tArray[i], SELECT_BY_TICKET);
      if(OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP)
         OrderDelete(tArray[i]);  
   }
   
   OrderSelect(t1, SELECT_BY_TICKET);
   if(OrderType() == OP_BUYSTOP)
      OrderDelete(t1);    
       
   OrderSelect(t2, SELECT_BY_TICKET);
   if(OrderType() == OP_SELLSTOP)
      OrderDelete(t2);           
   
   for(i=0; i<10; i++)           //preparing tArray[]
      tArray[i] = 0;

   T=0;
   t1=0;
   t2=0;
   
   
   BSP   = BuyStopPrice;         //needed restart flag
   flag  = 1;                    //main restart flag
   
   return (0);   
}